//Listing 12.3 Constructors and destructors called.

#include <iostream>
enum BREED {GOLDEN, CAIRN, DANDIE, SHETLAND, DOBERMAN, LAB};

class Mammal
{
public:
    // constructors
    Mammal();
   ~Mammal();

   //accessors
   int GetAge() const { return itsAge; }
   void SetAge(int age) { itsAge = age; }
   int GetWeight() const { return itsWeight; }
   void SetWeight(int weight) { itsWeight = weight; }

   //Other methods
   void Speak() const { std::cout << "Mammal sound!\n"; }
   void Sleep() const { std::cout <<
                               "shhh. I'm sleeping.\n"; }

protected:
   int itsAge;
   int itsWeight;
};

class Dog : public Mammal
{
public:

   // Constructors
   Dog();
   ~Dog();

   // Accessors
   BREED GetBreed() const { return itsBreed; }
   void SetBreed(BREED breed) { itsBreed = breed; }

   // Other methods
   void WagTail() const { std::cout << "Tail wagging..\n";}
   void BegForFood() const { std::cout <<
                                 "Begging for food...\n"; }
private:
   BREED itsBreed;
};

Mammal::Mammal():
itsAge(1),
itsWeight(5)
{
   std::cout << "Mammal constructor...\n";
}

Mammal::~Mammal()
{
   std::cout << "Mammal destructor...\n";
}

Dog::Dog():
itsBreed(GOLDEN)
{
   std::cout << "Dog constructor...\n";
}

Dog::~Dog()
{
   std::cout << "Dog destructor...\n";
}
int main()
{
   Dog fido;
   fido.Speak();
   fido.WagTail();
   std::cout << "Fido is " << fido.GetAge() << " years old\n";
   return 0;
}
